/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.

  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
*/
#ifndef _ADV202_HDR_H
#define _ADV202_HDR_H 1

typedef struct _ADV202_COMPRESSED_HEADER
{
	unsigned long Field;
	unsigned long Index;
	union
	{
		unsigned long Info;
	 struct {
		 unsigned char Version;
		 unsigned char Reserved;
		 unsigned char VideoFormat;
		 unsigned char CodeFormat;
	 } Info_s;
	} Info_u;
	unsigned long Size;


} ADV202_COMPRESSED_HEADER, *PADV202_COMPRESSED_HEADER;

#define	ADV202_COMPRESSED_HEADER_FIELD_EVEN			0xFFFFFFF0L
#define	ADV202_COMPRESSED_HEADER_FIELD_ODD			0xFFFFFFF1L

#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_RAW		0x01
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_J2C		0x02
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_JP2		0x04
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_HDR		0x08
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_EPH		0x10
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_SOP		0x20
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_PLT		0x40
#define	ADV202_COMPRESSED_HEADER_CODE_FORMAT_PPT		0x80
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_NTSC		0x00
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_PAL		0x01
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_1080_Y	        0x02
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_1080_CH	        0x03
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_CUSTOM	        0x04
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_720P_60_Y	        0x05
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_720P_60_CH	0x06
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_NTSC_DI		0x08
#define	ADV202_COMPRESSED_HEADER_VIDEO_FORMAT_PAL_DI		0x09

#define	ADV202_COMPRESSED_HEADER_VERSION_FF82	0x02



typedef struct _ADV202_IMAGE_HEADER
{
	unsigned long	Signature;
	unsigned long	Format;
}ADV202_IMAGE_HEADER, *PADV202_IMAGE_HEADER;

#define	ADV202_IMAGE_HEADER_SIGN	                0x48695069L	//"HiPi"
#define	ADV202_IMAGE_HEADER_FORMAT_UNDEF		0x00
#define	ADV202_IMAGE_HEADER_FORMAT_640_480_8B_422	0x01
#define	ADV202_IMAGE_HEADER_FORMAT_640_480_16B_LUMA	0x02



#define	FW_VIDEO_ENCODE		0x00
#define	FW_VIDEO_DECODE		0x01
#define	FW_HIPI_ENCODE		0x02
#define	FW_HIPI_DECODE		0x03
#define	FW_HIPI_LOOP		0x04


#endif
