/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.

  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
******************************************************************************/
#ifndef 	_UTILS_H
#define	_UTILS_H
#include "driver.h"

#ifndef	TRUE
#define	TRUE 1
#endif

#ifndef	FALSE
#define	FALSE 0
#endif

#ifndef IN
#define IN
#endif

#ifndef OUT
#define OUT
#endif

#ifndef YES
#define YES	1
#endif

#ifndef NO
#define NO	0
#endif


#ifndef UNREF_PARAM
#define UNREF_PARAM(x) (x=x)
#endif

#ifndef INVALID_HANDLE
#define	INVALID_HANDLE(h)	\
	( (h) == INVALID_HANDLE_VALUE )
	#endif

#ifndef	NULL_PTR
#define NULL_PTR(p)	\
	( (p) == NULL )
#endif

#define DIM(x) (sizeof(x)/sizeof(x[0]))

#define	IGNORE_PARAM	0x00

#define	CLR_BIT(x,y)	\
	( (x) &= ~(y) )

#define	SET_BIT(x,y)	\
	( (x) |= (y) )


/*Translate to/from little-endian 32-bit word from/to big-endian*/
#define 	SWAP_ULONG(x)	( ( ( ((unsigned long)(x) ) >> 24 ) & 0x000000FFL ) |	\
								( ( ( (unsigned long)(x) ) >> 8  ) & 0x0000FF00L )   |  	\
								( ( ( (unsigned long)(x) ) << 24 ) & 0xFF000000L )   |  	\
								( ( ( (unsigned long)(x) ) << 8 )  & 0x00FF0000L ) )

/*Build a 32-bit word from 4 bytes
since we 'are' little endian BYTE_0 is  put on lower data path:
if the target is big endian BYTE_0 will be the MSB*/
#define	BYTES_TO_ULONG(BYTE_0,BYTE_1,BYTE_2,BYTE_3) \
	(	(((unsigned long)(BYTE_0))&0xFFL) 					|	\
		((((unsigned long)(BYTE_1)) << 8) & 0xFF00L) 		|	\
		((((unsigned long)(BYTE_2)) << 16) & 0xFF0000L) 	|	\
		((((unsigned long)(BYTE_3)) << 24) & 0xFF000000L) )

/*ADV202 16 bit registers must be << 16*/
#define ADV202_REG16(x)	\
	(((unsigned long)(x) << 16)&0xFFFF0000L)


#endif	// _UTILS_H
