#!/bin/sh
# Silly wrapping of insmod to allow dynamic major numbers
#

# Edit to suit your needs:
OWNER=root
GROUP=root
MODE=ugo+rw

FILE="ctr1474.ko"
DEV="ctr1474"
VER=`uname -r`

if [ -f linux/$FILE ]; then
    MPATH=linux/$FILE; 
else if [ -f /lib/modules/$VER/misc/$FILE ]; then
    MPATH=/lib/modules/$VER/misc/$FILE;
else
    echo "Cannot find $FILE"
    exit 1
fi; fi

rmmod $DEV
echo -n "Loading $DEV device driver ($MPATH)..."
if /sbin/insmod $MPATH $*; then
   echo -n ...
else
   echo " failed"
   exit 1
fi

MAJOR=`cat /proc/devices | grep " plx$" | awk '{print $1}' | head -1`

# Make the device files
rm -rf /dev/$DEV*
boards=2			# TODO: make configurable
for n in $(seq 0 $(expr $boards - 1)) ; do
   nn=$(expr $n + $n)
   nn1=$(expr $nn + 1)
   nn2=$(expr 128 + $n)

   mknod -m ugo+rw /dev/${DEV}-${n}enc  c $MAJOR $nn
   mknod -m ugo+rw /dev/${DEV}-${n}dec  c $MAJOR $nn1
   mknod -m ugo+rw /dev/${DEV}-${n}ctrl c $MAJOR $nn2
done

echo "done"
exit 0
